unit Package_1Unit;

interface

uses
  System.ComponentModel,
  System.Collections,
  Borland.Eco.Services,
  Borland.Eco.ObjectRepresentation,
  Borland.Eco.ObjectImplementation,
  Borland.Eco.UmlRt,
  Borland.Eco.UmlCodeAttributes;

type
  c_invoice = class;
  c_item = class;
  [UmlElement('Package', Id='DFA29EDF-DDBC-48B5-9B40-2CEB8F2A43C6')]
  [EcoCodeGenVersion('2.0')]
  [UmlMetaAttribute('ownedElement', TypeOf(c_invoice))]
  [UmlMetaAttribute('ownedElement', TypeOf(c_item))]
  Package_1 = class
  public
  type
    [UmlElement('Association', Id='11812ac4-0b15-40af-8a19-07e63ff5f9ef')]
    c_invoicefrom_invoicec_itemhas_item = class
    end;
  end;

  [assembly: RuntimeRequired(TypeOf(Package_1))]
  Ic_invoiceList = interface;
  [UmlCollection(TypeOf(c_invoice))]
  Ic_invoiceList = interface(ICollection)
    {$REGION 'ECO generated code'}
    function get_Item(index: Integer): c_invoice;
    procedure set_Item(index: Integer; Value: c_invoice);
    property Item[index: Integer]: c_invoice read get_Item write set_Item; default;
    function Add(value: c_invoice): Integer;
    function Contains(value: c_invoice): Boolean;
    function IndexOf(value: c_invoice): Integer;
    procedure Insert(index: Integer; value: c_invoice);
    procedure Remove(value: c_invoice);
    procedure Clear;
    procedure RemoveAt(index: Integer);
    {$ENDREGION 'ECO generated code'}
  end;
  Ic_itemList = interface;
  
  [UmlElement(Id='c51e160f-08ce-462a-a438-0fc29b75ad74')]
  c_invoice = class(System.Object, ILoopBack)
    {$REGION 'ECO generated code'}
  public
  type
    Eco_LoopbackIndices = class
    public
    const
      Eco_FirstMember = 0;
    const
      Eco_MemberCount = (Eco_FirstMember + 3);
    const
      m_invoice_number = Eco_FirstMember;
    const
      m_customer = (Eco_LoopbackIndices.m_invoice_number + 1);
    const
      has_item = (Eco_LoopbackIndices.m_customer + 1);
    end;

    c_invoiceListAdapter = class(ObjectListAdapter, Ic_invoiceList)
    public
      constructor Create(source: IList);
      function get_Item(index: Integer): c_invoice;
      procedure set_Item(index: Integer; Value: c_invoice);
      property Item[index: Integer]: c_invoice read get_Item write set_Item; default;
      function Add(value: c_invoice): Integer;
      function Contains(value: c_invoice): Boolean;
      function IndexOf(value: c_invoice): Integer;
      procedure Insert(index: Integer; value: c_invoice);
      procedure Remove(value: c_invoice);
    end;
    
  strict protected
    eco_Content: IContent;
  strict private
    function IObjectProvider.AsIObject = IObjectProvider_AsIObject;
    function IObjectProvider_AsIObject: IObject;
  public
    function AsIObject: IObjectInstance;
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    function get_m_customer: string;
    procedure set_m_customer(Value: string);
    [UmlElement(Id='b9b250b7-ab97-465a-8886-e84e9498831b', Index=Eco_LoopbackIndices.m_customer)]
    property m_customer: string read get_m_customer write set_m_customer;
    function get_m_invoice_number: Integer;
    procedure set_m_invoice_number(Value: Integer);
    [UmlElement(Id='a4cb9fff-367c-43e4-b141-d34382ca5044', Index=Eco_LoopbackIndices.m_invoice_number)]
    property m_invoice_number: Integer read get_m_invoice_number write set_m_invoice_number;
    function get_has_item: Ic_itemList;
    [UmlElement('AssociationEnd', Index=Eco_LoopbackIndices.has_item, Id='3ab58f6' +
    '7-acde-456d-946d-2ca5dad73f22')]
    [UmlMetaAttribute('association', TypeOf(Package_1.c_invoicefrom_invoicec_itemhas_item), Index=1)]
    [UmlMetaAttribute('multiplicity', '1..*')]
    property has_item: Ic_itemList read get_has_item;
  strict protected
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    /// <summary>For Framework Internal use only</summary>
  public
    constructor Create(content: IContent); overload;
    {$ENDREGION 'ECO generated code'}
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;
  [UmlCollection(TypeOf(c_item))]
  Ic_itemList = interface(ICollection)
    {$REGION 'ECO generated code'}
    function get_Item(index: Integer): c_item;
    procedure set_Item(index: Integer; Value: c_item);
    property Item[index: Integer]: c_item read get_Item write set_Item; default;
    function Add(value: c_item): Integer;
    function Contains(value: c_item): Boolean;
    function IndexOf(value: c_item): Integer;
    procedure Insert(index: Integer; value: c_item);
    procedure Remove(value: c_item);
    procedure Clear;
    procedure RemoveAt(index: Integer);
    {$ENDREGION 'ECO generated code'}
  end;
  
  [UmlElement(Id='0f9be3ca-c673-401a-bf41-bbdbfe71d98e')]
  c_item = class(System.Object, ILoopBack)
    {$REGION 'ECO generated code'}
  public
  type
    Eco_LoopbackIndices = class
    public
    const
      Eco_FirstMember = 0;
    const
      Eco_MemberCount = (Eco_FirstMember + 3);
    const
      m_quantity = Eco_FirstMember;
    const
      m_price = (Eco_LoopbackIndices.m_quantity + 1);
    const
      from_invoice = (Eco_LoopbackIndices.m_price + 1);
    end;

    c_itemListAdapter = class(ObjectListAdapter, Ic_itemList)
    public
      constructor Create(source: IList);
      function get_Item(index: Integer): c_item;
      procedure set_Item(index: Integer; Value: c_item);
      property Item[index: Integer]: c_item read get_Item write set_Item; default;
      function Add(value: c_item): Integer;
      function Contains(value: c_item): Boolean;
      function IndexOf(value: c_item): Integer;
      procedure Insert(index: Integer; value: c_item);
      procedure Remove(value: c_item);
    end;
    
  strict protected
    eco_Content: IContent;
  strict private
    function IObjectProvider.AsIObject = IObjectProvider_AsIObject;
    function IObjectProvider_AsIObject: IObject;
  public
    function AsIObject: IObjectInstance;
    procedure set_MemberByIndex(index: Integer; value: System.Object); virtual;
    function get_MemberByIndex(index: Integer): System.Object; virtual;
    function get_from_invoice: c_invoice;
    procedure set_from_invoice(Value: c_invoice);
    [UmlElement('AssociationEnd', Index=Eco_LoopbackIndices.from_invoice, Id='f11' +
    '61063-0738-491a-bcc8-1ec92c86714f')]
    [UmlMetaAttribute('association', TypeOf(Package_1.c_invoicefrom_invoicec_itemhas_item), Index=0)]
    [UmlMetaAttribute('multiplicity', '1')]
    property from_invoice: c_invoice read get_from_invoice write set_from_invoice;
    function get_m_quantity: Integer;
    procedure set_m_quantity(Value: Integer);
    [UmlElement(Id='a26eac55-de39-4faa-b367-de00fd33d2bf', Index=Eco_LoopbackIndices.m_quantity)]
    property m_quantity: Integer read get_m_quantity write set_m_quantity;
    function get_m_price: Double;
    procedure set_m_price(Value: Double);
    [UmlElement(Id='ef37270c-cc93-45e5-8955-150d37ce1e53', Index=Eco_LoopbackIndices.m_price)]
    property m_price: Double read get_m_price write set_m_price;
  strict protected
    procedure Deinitialize(serviceProvider: IEcoServiceProvider);
    procedure Initialize(serviceProvider: IEcoServiceProvider);
    /// <summary>For Framework Internal use only</summary>
  public
    constructor Create(content: IContent); overload;
    {$ENDREGION 'ECO generated code'}
    constructor Create(serviceProvider: IEcoServiceProvider); overload;
  end;

implementation

function c_invoice.IObjectProvider_AsIObject: IObject;
begin
  Result := Self.eco_Content.AsIObject;
end;

function c_invoice.AsIObject: IObjectInstance;
begin
  Result := Self.eco_Content.AsIObject;
end;

procedure c_invoice.set_MemberByIndex(index: Integer; value: System.Object);
begin
  raise System.IndexOutOfRangeException.Create;
end;

function c_invoice.get_MemberByIndex(index: Integer): System.Object;
begin
  raise System.IndexOutOfRangeException.Create;
end;

procedure c_invoice.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self.eco_Content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self.eco_Content, Self);
    Self.eco_Content := nil;
  end;
end;

procedure c_invoice.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self.eco_Content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self.eco_Content := factory.CreateContent(Self);
    Self.eco_Content.LoopbackValid;
  end;
end;

/// <summary>For Framework Internal use only</summary>
constructor c_invoice.Create(content: IContent);
begin
  inherited Create;
  Self.eco_Content := content;
  content.AssertLoopbackUnassigned;
end;

{$ENDREGION 'ECO generated code'}

constructor c_invoice.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // User code here
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

constructor c_invoice.c_invoiceListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function c_invoice.c_invoiceListAdapter.get_Item(index: Integer): c_invoice;
begin
  Result := (c_invoice(inherited Adaptee[index]));
end;

procedure c_invoice.c_invoiceListAdapter.set_Item(index: Integer; Value: c_invoice);
begin
  inherited Adaptee[index] := value;
end;

function c_invoice.c_invoiceListAdapter.Add(value: c_invoice): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function c_invoice.c_invoiceListAdapter.Contains(value: c_invoice): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function c_invoice.c_invoiceListAdapter.IndexOf(value: c_invoice): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure c_invoice.c_invoiceListAdapter.Insert(index: Integer; value: c_invoice);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure c_invoice.c_invoiceListAdapter.Remove(value: c_invoice);
begin
  Self.Adaptee.Remove(value);
end;

function c_invoice.get_has_item: Ic_itemList;
begin
  Result := Package_1Unit.c_item.c_itemListAdapter.Create((IList(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.has_item))));
end;

function c_invoice.get_m_invoice_number: Integer;
begin
  Result := (Integer(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.m_invoice_number)));
end;

procedure c_invoice.set_m_invoice_number(Value: Integer);
begin
  Self.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.m_invoice_number, (System.Object(Value)));
end;

function c_invoice.get_m_customer: string;
begin
  Result := (string(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.m_customer)));
end;

procedure c_invoice.set_m_customer(Value: string);
begin
  Self.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.m_customer, (System.Object(Value)));
end;

function c_item.IObjectProvider_AsIObject: IObject;
begin
  Result := Self.eco_Content.AsIObject;
end;

function c_item.AsIObject: IObjectInstance;
begin
  Result := Self.eco_Content.AsIObject;
end;

procedure c_item.set_MemberByIndex(index: Integer; value: System.Object);
begin
  raise System.IndexOutOfRangeException.Create;
end;

function c_item.get_MemberByIndex(index: Integer): System.Object;
begin
  raise System.IndexOutOfRangeException.Create;
end;

procedure c_item.Deinitialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self.eco_Content <> nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    factory.CreateContentFailed(Self.eco_Content, Self);
    Self.eco_Content := nil;
  end;
end;

procedure c_item.Initialize(serviceProvider: IEcoServiceProvider);
var
  factory: IInternalObjectContentFactory;
begin
  if (Self.eco_Content = nil) then
  begin
    factory := (IInternalObjectContentFactory(serviceProvider.GetEcoService(TypeOf(IInternalObjectContentFactory))));
    Self.eco_Content := factory.CreateContent(Self);
    Self.eco_Content.LoopbackValid;
  end;
end;

/// <summary>For Framework Internal use only</summary>
constructor c_item.Create(content: IContent);
begin
  inherited Create;
  Self.eco_Content := content;
  content.AssertLoopbackUnassigned;
end;

{$ENDREGION 'ECO generated code'}

constructor c_item.Create(serviceProvider: IEcoServiceProvider);
begin
  inherited Create;
  Self.Initialize(serviceProvider);
  try
    // User code here
  except
    on System.Exception do
    begin
      Self.Deinitialize(serviceProvider);
      raise;
    end;
  end;
end;

function c_item.get_m_price: Double;
begin
  Result := (Double(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.m_price)));
end;

procedure c_item.set_m_price(Value: Double);
begin
  Self.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.m_price, (System.Object(Value)));
end;

function c_item.get_m_quantity: Integer;
begin
  Result := (Integer(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.m_quantity)));
end;

procedure c_item.set_m_quantity(Value: Integer);
begin
  Self.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.m_quantity, (System.Object(Value)));
end;

constructor c_item.c_itemListAdapter.Create(source: IList);
begin
  inherited Create(source);
end;

function c_item.c_itemListAdapter.get_Item(index: Integer): c_item;
begin
  Result := (c_item(inherited Adaptee[index]));
end;

procedure c_item.c_itemListAdapter.set_Item(index: Integer; Value: c_item);
begin
  inherited Adaptee[index] := value;
end;

function c_item.c_itemListAdapter.Add(value: c_item): Integer;
begin
  Result := Self.Adaptee.Add(value);
end;

function c_item.c_itemListAdapter.Contains(value: c_item): Boolean;
begin
  Result := Self.Adaptee.Contains(value);
end;

function c_item.c_itemListAdapter.IndexOf(value: c_item): Integer;
begin
  Result := Self.Adaptee.IndexOf(value);
end;

procedure c_item.c_itemListAdapter.Insert(index: Integer; value: c_item);
begin
  Self.Adaptee.Insert(index, value);
end;

procedure c_item.c_itemListAdapter.Remove(value: c_item);
begin
  Self.Adaptee.Remove(value);
end;

procedure c_item.set_from_invoice(Value: c_invoice);
begin
  Self.eco_Content.set_MemberByIndex(Eco_LoopbackIndices.from_invoice, (System.Object(Value)));
end;

function c_item.get_from_invoice: c_invoice;
begin
  Result := (Package_1Unit.c_invoice(Self.eco_Content.get_MemberByIndex(Eco_LoopbackIndices.from_invoice)));
end;

{ Package_1 }


end.
